package me.Prometheus.DeGriefer;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.logging.Logger;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

public class DeGriefer extends JavaPlugin
{
	public static DeGriefer plugin;
	public final Logger logger = Logger.getLogger("Minecraft");
	public List<String> dgPlayerList;
	public boolean Active = true;
	public String confPath = "plugins" + File.separator + "DeGriefer"+ File.separator + "dgConfig.yml";
	private String dataPath = "plugins" + File.separator + "DeGriefer"+ File.separator + "blockData.dat";
	public YamlConfiguration DataWorker = YamlConfiguration.loadConfiguration(new File(confPath));
	DeGrieferHashMap dataStore = null;
	
	
	public void onEnable()
	{
		PluginManager pm = getServer().getPluginManager();
		pm.registerEvents(new DeGrieferListener(this), this);
		PluginDescriptionFile pdfFile = this.getDescription();
		try {
			dataStore = new DeGrieferHashMap(dataPath);
		} catch (ClassNotFoundException | IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		File yEx = new File(confPath);
		if (!yEx.exists())
		{
			DataWorker.set("WhiteList", false);
			DataWorker.set("consoleOnly", true);
			try
			{
				DataWorker.save(confPath);
			} catch (IOException e)
			{
				logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
			}
		}
		if (yEx.exists())
		{
			try
			{
				DataWorker.load(confPath);
			} catch (IOException | InvalidConfigurationException e)
			{
				logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
			}
		}
		dgPlayerList = DataWorker.getStringList("uList");
		this.logger.info("[" + pdfFile.getName() + "] version " + pdfFile.getVersion() + " is enabled.");
	}

	public void onDisable()
	{
		PluginDescriptionFile pdfFile = this.getDescription();
		this.logger.info("[" + pdfFile.getName() + "] is now disabled.");
	}

	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args)
	{
		if (commandLabel.equalsIgnoreCase("dg") || commandLabel.equalsIgnoreCase("degriefer") || commandLabel.equalsIgnoreCase("degrief"))
		{
			if (sender.hasPermission("degriefer.canusecmds"))
			{
				{
					if (args.length > 0)
					{
						if (args[0].equalsIgnoreCase("help"))
						{
							sender.sendMessage("/dg and /degreif can be used in place of /degreifer");
							sender.sendMessage("Input is not case-sensitive, \"abc\" is the same as \"ABC\".");
							sender.sendMessage("/dg on - Activates the protection features of this plugin.");
							sender.sendMessage("/dg off - Deactivates the protection features of this plugin.");
							sender.sendMessage("/dg purge <name> - Removes protection from blocks the user placed. ");
							sender.sendMessage("/dg add <name> - Adds the user to the whitelist.");
							sender.sendMessage("/dg remove <name> - Removes the user from the whitelist.");
							sender.sendMessage("/dg clearlist (or listclear) - Removes all names from the whitelist. Defaults to console-only.");
							sender.sendMessage("WhiteList mode is enabled to disabled depending on your Server Admin.");
						}
						if (args[0].equalsIgnoreCase("on"))
						{
							Player p = (Player) sender;
							if (dataStore.read(p.getWorld().getName()) != null)
							{
								if(dataStore.read(p.getWorld().getName()) != "true")
								{
									dataStore.write(p.getWorld().getName(), "true");
									sender.sendMessage("DeGriefer is now on! Your blocks are safe!");
								}
								else
								{
									sender.sendMessage("DeGriefer is already on!");
								}
							}
							else
							{
								dataStore.write(p.getWorld().getName(), "true");
								sender.sendMessage("DeGriefer is now on! Your blocks are safe!");
							}
						}
						if (args[0].equalsIgnoreCase("off"))
						{
							Player p = (Player) sender;
							if (dataStore.read(p.getWorld().getName()) != null)
							{
								if(dataStore.read(p.getWorld().getName()) != "false")
								{
									dataStore.write(p.getWorld().getName(), "false");
									sender.sendMessage("DeGriefer is now off! Watch your blocks!");
								}
								else
								{
									sender.sendMessage("DeGriefer is already off!");
								}
							}
							else 
							{
								dataStore.write(p.getWorld().getName(), "false");
								sender.sendMessage("DeGriefer is now off! Watch your blocks!");
							}
						}
						if (args[0].equalsIgnoreCase("purge"))
						{
							if (args.length == 3 && args[2].equalsIgnoreCase("yes"))
							{
								String user = args[1].toLowerCase();
								dataStore.purgeValue(user);
								sender.sendMessage("All protection for " + user + "'s blocks has been removed.");
							}
							else
							{
								sender.sendMessage("Are you sure? This is very resource intensive!");
								sender.sendMessage("Type \"/purge <name> yes\" to go through with it!");
							}
						}
						if (args[0].equalsIgnoreCase("add"))
						{
							String user = args[1].toLowerCase();
							dgPlayerList.add(user);
							DataWorker.set("uList", dgPlayerList);
							try
							{
								DataWorker.save(confPath);
								sender.sendMessage(user + " has been added to the list!");
							} catch (IOException e)
							{
								logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
							}

						}
						if (args[0].equalsIgnoreCase("remove"))
						{
							String user = args[1].toLowerCase();
							dgPlayerList.remove(user);
							DataWorker.set("uList", dgPlayerList);
							try
							{
								DataWorker.save(confPath);
								sender.sendMessage(user	+ " has been removed from the list!");
							}
							catch (IOException e)
							{
								logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
							}

						}
						if (args[0].equalsIgnoreCase("clearlist") || args[0].equalsIgnoreCase("listclear"))
						{
							boolean cOnly = DataWorker.getBoolean("consoleOnly");
							if (cOnly == true)
							{
								Player p = null;
								if (sender instanceof Player)
								{
									p = (Player) sender;
								}
								if (p == null)
								{
									dgPlayerList.clear();
									DataWorker.set("uList", dgPlayerList);
									try
									{
										DataWorker.save(confPath);
										logger.info("List cleared!");
									} catch (IOException e)
									{
										logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
									}
								} else
								{
									sender.sendMessage("Sorry! You're not allowed to do that.");
								}
							}
							if (cOnly == false)
							{
								if (sender .hasPermission("degriefer.canusecmds"))
								{
									dgPlayerList.clear();
									DataWorker.set("uList", dgPlayerList);
									try
									{
										DataWorker.save(confPath);
										sender.sendMessage("List cleared!");
									} catch (IOException e)
									{
										logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
									}
								}
							}
						}
						return true;
					}
				}
			}
		}
		return false;
	}
}