package me.Prometheus.DeGriefer;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map.Entry;
import java.util.NoSuchElementException;

public class DeGrieferHashMap {
	private HashMap<String, String> map;
	private String path;

	@SuppressWarnings("unchecked")
	public DeGrieferHashMap(String path) throws IOException,
			ClassNotFoundException {
		this.path = path;
		try {
			FileInputStream f = new FileInputStream(path);
			ObjectInputStream s = new ObjectInputStream(f);
			map = (HashMap<String, String>) s.readObject();
			s.close();
			f.close();
		} catch (FileNotFoundException e) { // never been saved before.
			map = new HashMap<String, String>();
		}
	}

	public String read(String key) {
		return map.get(key);
	}

	public String write(String key, String value) { // can ignore result
		return map.put(key, value);
	}
	
	public void purgeValue(String value) {
		Iterator<Entry<String, String>> iterator = map.entrySet().iterator();
		Entry<String, String> next;
		try {
			while (true) {
				next = iterator.next();
				if (value.equals(next.getValue())) {
					iterator.remove();
				}
			}
		}
		catch (NoSuchElementException e) {}
	}

	public void persist() throws IOException {
		FileOutputStream f = new FileOutputStream(path);
		ObjectOutputStream s = new ObjectOutputStream(f);
		s.writeObject(map);
		s.flush();
		s.close();
		f.close();
	}
}